#ifndef _XSOCK_ERRORS
#define _XSOCK_ERRORS 1

#include <exception>

namespace XSockExcept {
	class eXSockExcept : public std::exception { };
	class eInvalidSocket : public eXSockExcept { };
	class eUnknownProtocol : public eXSockExcept { };
	class eUnableToListen : public eXSockExcept { };
	class eUnableToConnect : public eXSockExcept { };
	class eUnableToAccept : public eXSockExcept { };
	class eUnableToBind : public eXSockExcept { };
	class eSockUnreadable : public eXSockExcept { };
	class eSockUnwritable : public eXSockExcept { };
	class eUnknownXSockRole : public eXSockExcept { };
	class eUnableToResolveName : public eXSockExcept { };
	class eXSockNotReady : public eXSockExcept { };
	class eConnectionClosedByPeer : public eXSockExcept { };
	class eDeadLock : public eXSockExcept { };
	class eUnableToLock : public eXSockExcept { };
	class eUnableToUnlock : public eXSockExcept { };
	class eUnableToCloseFile : public eXSockExcept { };
	class eUnableToOpenFile : public eXSockExcept { };
    class eUnableToStatFile : public eXSockExcept { };
	class eUnableToOpen2ndFile : public eXSockExcept { };
	class eUnableToCreateFile : public eXSockExcept { };
	class eUnableToDeleteFile : public eXSockExcept { };
	class eUnableToReadFile : public eXSockExcept { };
	class eUnableToWriteFile : public eXSockExcept { };
	/* dfinition des exceptions ici */
	
}

#endif
